<?php
/**
 * The template for displaying a "No posts found" message.
 *
 * @package WordPress
 */
?>
<div class="box-center">
<div class="box-center-left">
<div class="left-left">
<header class="page-header">
	<h1 class="page-title"><?php _e( 'Nothing Found', 'journalbox' ); ?></h1>
</header>
<?php if ( is_home() && current_user_can( 'publish_posts' ) ) : ?>

	<p><?php printf( __( 'Ready to publish your first post? <a href="%1$s">Get started here</a>.', 'journalbox' ), admin_url( 'post-new.php' ) ); ?></p>

	<?php elseif ( is_search() ) : ?>

	<p><?php _e( 'Sorry, but nothing matched your search terms. Please try again with different keywords.', 'journalbox' ); ?></p>
	<?php get_search_form(); ?>

	<?php else : ?>

	<p><?php _e( 'It seems we can&rsquo;t find what you&rsquo;re looking for. Perhaps searching can help.', 'journalbox' ); ?></p>
	<?php get_search_form(); ?>

	<?php endif; ?>

</div>
</div>

</div>